package info.lotosummary.software;
import java.io.*;

public class Segmentalize extends Alterable {
    static final int NON_INDEX_NUMBER = 3;
    static final String CELL_01_02_03_04_05 = "01 02 03 04 05 ";
    static final String CELL_16_17_18_19_20 = "16 17 18 19 20 ";
    static final String CELL_26_27_28_29_30 = "26 27 28 29 30 ";
    static final String SENTINEL = "41";
    int row;

    private boolean integrity_of_data(String p) {
        boolean integrity = false;
        int q;

        String d = p;
        d += SENTINEL;
        int u = sequence_of_non_numbers(d, 0);
        String ball = d.substring(u, u + 2 );

        switch(row) {
        case 0:
            q = CELL_01_02_03_04_05.indexOf(ball);
            if(q >= 0) {
                row = 1;
                integrity = true;
            } else {
                row = 0;
                integrity = false;
            }

            break;
        case 1:
            q = CELL_16_17_18_19_20.indexOf(ball);
            if(q >= 0) {
                row = 2;
                integrity = true;
            } else {
                row = 0;
                integrity = false;
            }

            break;
        case 2:
            q = CELL_26_27_28_29_30.indexOf(ball);
            if(q >= 0) {
                row = NON_INDEX_NUMBER;
                integrity = true;
            } else {
                row = 0;
                integrity = false;
            }

            break;
        }

        if(integrity) {
            if(row == NON_INDEX_NUMBER) {
                row = 0;
            } else{
                integrity = false;
            }

        }

        return integrity;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    public boolean altering(String fileName) {
        Consecutive lineType;
        int r;
        String modelLine, s, NOTHING_ERRONEOUS;

// Reading SEGMENT_TEXT
        try {
            BufferedReader segment_text = new BufferedReader( new FileReader(list_of_items) );

            modelLine = segment_text.readLine();
            if(modelLine == null) {
                error = "e70: segment_text.readLine(): modelLine == null";
                return false;
            }

            lineType = new Consecutive(modelLine);
            r = lineType.dateLine();
            if(r > 0) {
                NOTHING_ERRONEOUS = lineType.pileOfErrorMessages();
            } else {
                error = "e36(lineType): " + modelLine;
                return false;
            }

            segment_text.close();
        } catch(IOException e49) {
            error = "IOException e49: " + list_of_items;
            return false;
        }

        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, TEXT_FILE);
            saveName = wt.temporaryName(serialNumber);
        }

// Reading WHO_TEXT
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
// Line-1
            s = buffered.readLine();
            if(s == null) {
                error = "e71(Line-1): s == null";
                return false;
            }

            if(firstLine) {
                add(s);
                listing();
                clear(modelLine);
            }

            int line = 0;
            error = NOTHING_ERRONEOUS;
            if(matrix) {
                for(;;) {
                    s = buffered.readLine();
                    if(s == null) {
                        break;
                    }

                    add(s);
                    line += 1;
                    if(line >= period) {
                        if( integrity_of_data(s) ) {
                            add(EMPTY); // NEW_LINE
                            s = lineType.rebuild();
                            add(s);
                            line = 0;
                        }

                    }

                }

            } else {
                for(;;) {
                    s = buffered.readLine();
                    if(s == null) {
                        break;
                    }

                    add(s);
                    line += 1;
                    if(line >= period) {
                        add(EMPTY); // NEW_LINE
                        s = lineType.rebuild();
                        add(s);
                        line = 0;
                    }

                }

            }

            buffered.close();
            listing();
            openSaveClose(saveName);
            return true;
        } catch(IOException e51) {
            error = "IOException e51: " + fileName;
            return false;
        }

    }

    public Segmentalize() {
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        row = 0;

        buffer = new StringBuffer();
        combos = new StringBuffer();
        whose = EMPTY;
    }

}
