package info.lotosummary.software;

public final class Singleton {
    private int i = 0;
    private static Singleton instance = new Singleton();
    private Singleton(){}

    public static Singleton getInstance() {
        return instance;
    }

    public int increment() {
        return ++i;
    }

    public void setTo(int data) {
        i = data;
    }

}

