package info.lotosummary.software;
import java.io.*;
import java.util.*;
import java.util.Arrays;

public class TableReverseSorted extends Alterable {
    static final boolean NO_SPLITTING = true;
    static final String REVERSE = "-1";
    static final String TABLE = "tab";
    static final String TABULATE_TEXT = "tabulate.txt";
    int[] countCopied = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; // LOTO_6_COUNT + 1
    long[] a = {0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L};

    private long[] longList(String s, String d) {
        int limit = LOTO_6_COUNT;
        String[] p = splitting(limit, s, d);
        int n = p.length;
        long[] long_list = new long[n];

        try {
            for(int i = 0; i < n; ++i) {
                long_list[i] = Long.parseLong(p[i]);
            }

        } catch(NumberFormatException e50) {
            error = "NumberFormatException e50";
        }

        return long_list;
    }

    private String[] splitting(int limit, String s, String d) {
        String[] p = new String[limit];
        StringTokenizer st = new StringTokenizer(s, d);

        for(int i = 0; i < limit; ++i) {
            if( st.hasMoreTokens() ) {
                p[i] = st.nextToken();
            } else {
                break;
            }

        }

        return p;
    }

    public boolean altering(String fileName) {
        Characterizable lineType;
        int articleCount = 0;
        int c, lineCount, m, r, factor, sum;
        String previous, s;
        TimeName ti;

        readingToProduceArray();
        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            if( BELL.equals(item[1]) ) { // extention
                ti = new TimeName(TABLE, TEXT_FILE);
            } else {
                ti = new TimeName(TABLE, item[1]);
            }

            saveName = ti.temporaryName(serialNumber);
        }

        try {
            BufferedReader test = new BufferedReader( new FileReader(fileName) );
// Line-1
            s = test.readLine();
            if(s == null) {
                error = "e72(Line-1): s == null";
                return false;
            }

            if(firstLine) {
                if( REMOVE_LINE_1.equals(item[0]) ) { // optional
                    ;
                } else {
                    buffer.append(s);
                    buffer.append(NEW_LINE);
                }

            }

            loto = checkLine1(s);
            switch(loto) {
            case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
                error = "e73: ADD THE DRAW TO LINE-1 OF WHO.TXT";
                return false;
            case TOO_FEW_GAPS:
                error = "e74: TOO FEW GAPS";
                return false;
            case MINILOTO:
                all = 31;
                break;
            case LOTO6:
                all = 43;
                break;
            case LOTO7:
                all = 37;
                break;
            default:
                break;
            }

            for(lineCount = 0; ; lineCount += 1) {
                s = test.readLine();
                if(s == null) {
                    break;
                }

            }

            test.close();
            String[] article = new String[lineCount];
            for(int i = 0; i < lineCount; ++i) {
                article[i] = COLON; // If sorted, numbers precede colons.
            }

            BufferedReader file = new BufferedReader( new FileReader(fileName) );
            for(int i = 0; i < lineCount; ++i) {
                s = file.readLine();
                lineType = new DateFollowed(s, NO_SPLITTING);
                r = lineType.dateLine();
                if(r > 0) {
                    continue;
                }

                s = countMeasureSort(s);
                if( s.length() > 0 ) {
                    article[articleCount] = s;
                    articleCount += 1;
                }

            }

            file.close();

// Sorting articles;
            Arrays.sort(article);

            s = COLON; // If sorted, numbers precede colons.
            for(int i = 0; i < articleCount; ++i) {
                previous = s;
                s = article[i];
                if( previous.equals(s) ) {
                    System.out.println(s);
                    continue;
                }

                a = longList(s, " ");
                for(int k = 0; k < loto; ++k) {
                    m = (int)a[k];
                    sum = count[m];
                    count[m] = sum + 1;
                }

            }

// reverse-sorting or not
            if( REVERSE.equals(item[2]) ) { // reverse-sort
                factor = -1;
            } else {
                factor = 1;
            }

// Setting flags and typically copying negative numbers
            for(int i = 1; i <= LOTO_6_COUNT; ++i) {
                check[i] = true;
                countCopied[i] = factor * count[i];
            }

// Sorting
            Arrays.sort(countCopied);

            for(int k = 0; k <= all; ++k) {
                c = factor * countCopied[k];

                for(int i = 1; i <= all; ++i) {
                    if(count[i] == c) {
                        if(check[i]) {
                            s =  String.valueOf(c);
                            buffer.append(ball[i]);
                            buffer.append(item[3]); // separator
                            buffer.append(s);
                            buffer.append(NEW_LINE);

                            check[i] = false;
                        }

                    }

                }

            }

            openSaveClose(saveName);
            return true;
        } catch(IOException e52) {
            error = "IOException e52";
            return false;
        }

    }

    public TableReverseSorted() {
        buffer = new StringBuffer();
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
    }

}
