package info.lotosummary.software;
import java.io.*;
import java.util.Arrays;

public abstract class Alterable {
    static final int ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT = 3;
    static final int LOTO_6_COUNT = 43;
    static final int FROM_START = 0;
    static final int GAP_SIZE = 1;
    static final int LOTO6 = 6;
    static final int LOTO7 = 7;
    static final int OMIT = -1;
    static final int MARK_INDEX = 5;
    static final int MINILOTO = 5;
    static final int NEAR = 2;
    static final int NOT_CONVERTED = -1;
    static final int TOKOBI_SIZE = 3;
    static final int TOO_FEW_GAPS = 4;
    static final int TRUE = 1;
    static final String AFTER = "F";
    static final String ANCHOR = ">>";
    static final String BEFORE = "F";
    static final String BELL = "\\a";
    static final String COLON = ":";
    static final String EMPTY = "";
    static final String GAP = " ";
    static final String MARK = "^";
    static final String MINUS = "-";
    static final String N_0TO9 = "0123456789";
    static final String REMOVE_LINE_1 = "-1-";
    static final String TEXT_FILE = ".txt";
    static final String TOKOBI = "e"; // Shift_JIS
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";
    static final String[] ball = {"", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43"};
    boolean firstLine, matrix, serialNumber, whoText;
    boolean[] check = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false}; // LOTO_6_COUNT + 1
    int all, itemCount, loto, NEW_LINE_LENGTH, period, span;
    int[] count = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; // LOTO_6_COUNT + 1
    int[] place = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}; // LOTO_6_COUNT + 1
    String error, list_of_items, NEW_LINE, saveName, sequence, whose;
    String[] item;
    StringBuffer buffer, combos;

    protected boolean countBallsMesureSpan(String s) {
        int c = 0;
        int q;

// Counting
        resettingPlaceArray();
        for(int i = 1; i <= all; ++i) {
            q = s.indexOf(ball[i]);
            place[i] = q;
            if(q >= 0) {
                c += 1;
            }

        }

        if(c != loto) {
            error = "e53: c != loto";
            return false;
        }

// Sorting places
        Arrays.sort(place);
        for(int i = 0; i <= LOTO_6_COUNT; ++i) {
            q = place[i];
            if(q == -1) {
                continue;
            } else if(q == 0) {
                continue;
            } else {
                span = q - place[ i - 1 ];
                if(span < NEAR) {
                    error = "e54: span < NEAR";
                    return false;
                }

            }

        }

        return true;
    }

    protected String countMeasureSort(String s) {
        int c = 0;
        int q;

// Counting
        resettingArrays();
        for(int i = 1; i <= all; ++i) {
            q = s.indexOf(ball[i]);
            place[i] = q;
            if(q >= 0) {
                c += 1;
                check[i] = true;
            }

        }

        if(c != loto) {
            error = "e55: c != loto";
            return EMPTY;
        }

// Sorting places
        Arrays.sort(place);
        for(int i = 0; i <= LOTO_6_COUNT; ++i) {
            q = place[i];
            if(q == -1) {
                continue;
            } else if(q == 0) {
                continue;
            } else {
                span = q - place[ i - 1 ];
                if(span < NEAR) {
                    error = "e56: span < NEAR";
                    return EMPTY;
                }

            }

        }

// Sorting balls
        StringBuffer combo = new StringBuffer();
        for(int i = 1; i <= all; ++i) {
            if(check[i]) {
                combo.append(ball[i]);
                combo.append(GAP);
            }

        }

// Trimming
        String g = combo.toString();
        int gap = g.length() - 1;
        return g.substring(0, gap);
    }

    protected boolean openSaveClose(String fileName) {
        try {
            BufferedWriter buffered = new BufferedWriter( new FileWriter(fileName) );
            String s = buffer.toString();
            int size = s.length();
            String c;
            for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
                c = s.substring(i, i + NEW_LINE_LENGTH );
                if( NEW_LINE.equals(c) ) {
                    continue;
                } else {
                    s = s.substring(i);
                    break;
                }

            }

            buffered.write(s);
            buffered.close();
            return true;
        } catch(IOException e4) {
            error = "IOException e4";
            return false;
        }

    }

    protected boolean readingToProduceArray() {
        int c = 0;
        String s;

// Reading list_of_items to produce an array
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(list_of_items) );

            for(int i = 0; ; ++i) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                c += 1;
            }

            buffered.close();
        } catch(IOException e2) {
            error = "IOException e2";
            return false;
        }

        itemCount = c;
        item = new String[itemCount];
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(list_of_items) );

            for(int i = 0; i < itemCount; ++i) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                if( s.length() > 0 ) {
                    item[i] = s;
                } else {
                    item[i] = BELL;
                }

            }

            buffered.close();
            return true;
        } catch(IOException e3) {
            error = "IOException e3";
            return false;
        }

    }

    protected boolean searchingItem(String s) {
        boolean found = false;
        int q;

        for(int i = 0; i < itemCount; ++i) {
            q = s.indexOf(item[i]);
            if(q >= 0) {
                found = true;
                break;
            }
        }

        return found;
    }

    protected boolean searchingItemSequence(String s) {
        boolean found = false;
        int q;

        for(int i = 0; i < itemCount; ++i) {
            q = s.indexOf(item[i]);
            if(q >= 0) {
                found = true;
                sequence = item[i];
                break;
            }
        }

        return found;
    }

    protected int checkLine1(String line) {
/*
012345678901234567890123456789012
31 18 15 06 14 25 
31 18 15 06 14 25 -A -776
35 29 12 16 13 28 05 
35 29 12 16 13 28 05 -B -548
04 26 32 29 05 25 15 27 11 
04 26 32 29 05 25 15 27 11 -D -92
*/
        int q;
        String s = line;
        for(int i = 0; i < 6; ++i) {
            q = s.indexOf(GAP);
            if(q >= 0) {
                q += GAP_SIZE;
                s = s.substring(q);
            } else {
                return TOO_FEW_GAPS;
            }

        }

        int lineLength = line.length();
        if(lineLength == 18) {
            return MINILOTO;
        }

        if( MINUS.equals( line.substring(18, 19) ) ) {
            return MINILOTO;
        }

        if(lineLength == 21) {
            return LOTO6;
        }

        if( MINUS.equals( line.substring(21, 22) ) ) {
            return LOTO6;
        }

        if(lineLength == 27) {
            return LOTO7;
        }

        if( MINUS.equals( line.substring(27, 28) ) ) {
            return LOTO7;
        }

        return ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT;
    }

    protected void add(String s) {
        combos.append(s);
        combos.append(NEW_LINE);
    }

    protected void clear(String s) {
        combos = new StringBuffer();
        whose = s;
    }

    protected void listing() {
        buffer.append(whose);
        buffer.append(NEW_LINE);
        buffer.append(combos);
    }

    protected void listing(String extra) {
        buffer.append(whose);
        buffer.append(NEW_LINE);
        buffer.append(combos);
        buffer.append(extra);
    }

    protected void resettingArrays() {
        for(int i = 0; i <= LOTO_6_COUNT; ++i) {
            check[i] = false;
            count[i] = 0;
            place[i] = OMIT;
        }

    }

    protected void resettingPlaceArray() {
        for(int i = 0; i <= LOTO_6_COUNT; ++i) {
            place[i] = OMIT;
        }

    }

    public String altered() {
        return saveName;
    }

    public int getLoto() {
        return loto;
    }

    public String inquiry() {
        return error;
    }

    public String getSequence() {
        return sequence;
    }

    public void setting(String l, int p, boolean f, boolean m, boolean s, boolean w) {
        firstLine = f;
        list_of_items = l;
        matrix = m;
        period = p;
        serialNumber = s;
        whoText = w;
    }

    public abstract boolean altering(String fileName);
}
