package info.lotosummary.software;
import java.io.*;

public class BetweenColons extends Alterable {

    public boolean altering(String fileName) {
        Characterizable lineType;
        int r;
        String s;

        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, TEXT_FILE);
            saveName = wt.temporaryName(serialNumber);
        }

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );

            s = buffered.readLine();
            if(s == null) {
                error = "e57(Line-1): s == null";
                return false;
            }

            if(firstLine) {
                add(s);
                listing();
                clear(EMPTY);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                lineType = new DateFollowed(s);
                r = lineType.dateLine();
                if(r > 0) {
                    listing();

                    s = lineType.interposed();
                    clear(s);
                    continue;
                }

                add(s);
            }

            buffered.close();
            listing();
            openSaveClose(saveName);
            return true;
        } catch(IOException e6) {
            error = "IOException e6";
            return false;
        }

    }

    public BetweenColons() {
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();

        buffer = new StringBuffer();
        combos = new StringBuffer();
        whose = EMPTY;
    }

}
