package info.lotosummary.software;
import java.io.*;

public class Combo extends Alterable {
    static final boolean NO_SPLITTING = true;
    static final boolean SERIAL_NUMBER = true;
    static final int ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT = 3;
    static final int FALSE = 0;
    static final String BOX_10TO6 = "10to6";
    static final String BOX_10TO7 = "10to7";
    static final String BOX_11TO7 = "11to7";
    static final String BOX_6TO5 = " 6to5";
    static final String BOX_7TO5 = " 7to5";
    static final String BOX_7TO6 = " 7to6";
    static final String BOX_8TO5 = " 8to5";
    static final String BOX_8TO6 = " 8to6";
    static final String BOX_8TO7 = " 8to7";
    static final String BOX_9TO5 = " 9to5";
    static final String BOX_9TO6 = " 9to6";
    static final String BOX_9TO7 = " 9to7";
    static final String COMBINATION = "cmb";

    int result;
    int[] ballCount;

    private boolean acquireFromFile(String fileName) {
        String s;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                add(s);
            }

            buffered.close();
            return true;
        } catch(IOException e37) {
            error = "IOException e37";
            return false;
        }

    }

    private int lookup() {
        int loto = 7;
        for(int i = 0; i < itemCount; ++i) {
            if( sequence.equals(item[i]) ) {
                loto = ballCount[i];
                break;
            }

        }

        return loto;
    }

    private String firstNumberTrimmed(String line) {
        String c;
        int lineLength = line.length();
        int q;

        for(int i = 0; i < lineLength; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                line = line.substring(i);
                lineLength = line.length();
                break;
            }

        }

        for(int i = lineLength - 1; i >= 0; --i) {
            c = line.substring(i, i + 1 );
            if( GAP.equals(c) ) {
                continue;
            } else {
                ++i;
                line = line.substring(0, i);
                break;
            }

        }

        return line;
    }

    private void produceArrays() {
        itemCount = 12;
        ballCount = new int[itemCount];
        item = new String[itemCount];
        item[0] = BOX_6TO5; ballCount[0] = 5;
        item[1] = BOX_7TO5; ballCount[1] = 5;
        item[2] = BOX_8TO5; ballCount[2] = 5;
        item[3] = BOX_9TO5; ballCount[3] = 5;
        item[4] = BOX_7TO6; ballCount[4] = 6;
        item[5] = BOX_8TO6; ballCount[5] = 6;
        item[6] = BOX_9TO6; ballCount[6] = 6;
        item[7] = BOX_10TO6; ballCount[7] = 6;
        item[8] = BOX_8TO7; ballCount[8] = 7;
        item[9] = BOX_9TO7; ballCount[9] = 7;
        item[10] = BOX_10TO7; ballCount[10] = 7;
        item[11] = BOX_11TO7; ballCount[11] = 7;
    }

    public boolean altering(String fileName) {
        boolean found;
        Characterizable lineType;
        int r;
        String combinationName, s;
        ToFive e;
        ToSeven n;
        ToSix x;

        produceArrays();
        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, TEXT_FILE);
            saveName = wt.temporaryName(serialNumber);
        }

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );

            s = buffered.readLine();
            if(s == null) {
                error = "e58: buffered.readLine(): " + fileName;
                return false;
            }

            if(firstLine) {
                add(s);
                listing();
                clear(EMPTY);
            }

            loto = checkLine1(s);
            switch(loto) {
            case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
                error = "e59: ADD THE DRAW TO LINE-1 OF WHO.TXT";
                return false;
            case TOO_FEW_GAPS:
                error = "e60: TOO FEW GAPS";
                return false;
            case MINILOTO:
                all = 31;
                break;
            case LOTO6:
                all = 43;
                break;
            case LOTO7:
                all = 37;
                break;
            default:
                break;
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                lineType = new DateFollowed(s, NO_SPLITTING);
                r = lineType.dateLine();
                if(r > 0) {
                    listing();
                    clear(s);
                    continue;
                }

                found = searchingItemSequence(s); // sequence = item[i]
                if(found) {
                    TimeName ct = new TimeName(COMBINATION, TEXT_FILE);
                    combinationName = ct.temporaryName(SERIAL_NUMBER);

                    s = firstNumberTrimmed(s);
                    loto = lookup(); // sequence
                    switch(loto) {
                    case MINILOTO:
                        e = new ToFive(combinationName, s);
                        result = e.writeFile();
                        if(result == FALSE) {
                            error = e.inquiry();
                            return false;
                        }

                        break;
                    case LOTO6:
                        x = new ToSix(combinationName, s);
                        result = x.writeFile();
                        if(result == FALSE) {
                            error = x.inquiry();
                            return false;
                        }

                        break;
                    case LOTO7:
                        n = new ToSeven(combinationName, s);
                        result = n.writeFile();
                        if(result == FALSE) {
                            error = n.inquiry();
                            return false;
                        }

                        break;
                    default:
                        error = "lookup()";
                        return false;
                    }

                    acquireFromFile(combinationName); // add(s)
                } else {
                    add(s);
                }

            }

            buffered.close();
            listing();
            openSaveClose(saveName);
            return true;
        } catch(IOException e38) {
            error = "IOException e38";
            return false;
        }

    }

    public Combo() {
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();

        buffer = new StringBuffer();
        combos = new StringBuffer();
        whose = EMPTY;
    }

    public String altered() {
        return saveName;
    }

    public String inquiry() {
        return error;
    }

}
