package info.lotosummary.software;
import java.io.*;

public class Dates extends Alterable {
    static final boolean NO_SPLITTING = true;

    public boolean altering(String fileName) {
        Characterizable lineType;
        int r;
        String s;

        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, TEXT_FILE);
            saveName = wt.temporaryName(serialNumber);
        }

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
// Line-1
            s = buffered.readLine();
            if(s == null) {
                error = "e63: Line-1: s == null";
                return false;
            }

            if(firstLine) {
                buffer.append(s);
                buffer.append(NEW_LINE);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                lineType = new DateFollowed(s, NO_SPLITTING);
                r = lineType.dateLine();
                if(r > 0) {
                    buffer.append(s);
                    buffer.append(NEW_LINE);
                }

            }

            buffered.close();
            openSaveClose(saveName);
            return true;
        } catch(IOException e34) {
            error = "IOException e34";
            return false;
        }

    }

    public Dates() {
        buffer = new StringBuffer();
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
    }

}
