package info.lotosummary.software;
import java.io.*;

public class FormDateLine extends Alterable {
    static final int RING_COUNT = 3;
    static final String ID_COLON = " ID:";

    Queue ring;
    String[] new_line;
    String[] separator;

    private int produceRingBuffer(int size) {
        String BLANK = " ";
        ring.clear();
        for(int i = 0; i < size; i += 1) {
            ring.push_back(BLANK);
        }

        return ring.queue_size();
    }

    private void blankRingBuffer() {
        String BLANK = " ";
        ring.pop_front();
        ring.push_back(BLANK);
        ring.pop_front();
        ring.push_back(BLANK);
        ring.pop_front();
        ring.push_back(BLANK);
    }

    public boolean altering(String fileName) {
        Characterizable lineType;
        int q, r;
        String s = EMPTY;
        StringBuffer os;

        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, TEXT_FILE);
            saveName = wt.temporaryName(serialNumber);
        }

// ring buffer
        produceRingBuffer(RING_COUNT);

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
// Line-1
            s = buffered.readLine();
            if(s == null) {
                error = "e66(Line-1): s == null";
                return false;
            }

            if(firstLine) {
                add(s);
                listing();
                clear(EMPTY);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                ring.pop_front();
                ring.push_back(s);

                q = s.indexOf(ID_COLON);
                if(q >= 0) {
                    s = ring.chain(separator);
                    lineType = new DateFollowed(s);
                    r = lineType.dateLine();
                    if(r > 0) {
                        listing();

                        s = lineType.interposed();
                        clear(s);
                        blankRingBuffer();
                        continue;
                    } else {
                        s = ring.front();
                    }

                } else {
                    s = ring.front();
                }

                add(s);
            }

            buffered.close();

            ring.pop_front();
            s = ring.chain(new_line);
            add(s);

            listing();
            openSaveClose(saveName);

            return true;
        } catch(IOException e13) {
            error = "IOException e13: " + fileName;
            return false;
        }

    }

    public FormDateLine() {
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();

        new_line = new String[RING_COUNT];
        for(int i = 0; i < RING_COUNT; ++i) {
            new_line[i] = NEW_LINE;
        }

        separator = new String[RING_COUNT];
        separator[0] = EMPTY;
        for(int i = 1; i < RING_COUNT; ++i) {
            separator[i] = GAP;
        }

        buffer = new StringBuffer();
        combos = new StringBuffer();
        ring = new Queue();
        whose = EMPTY;
    }

}
