package info.lotosummary.software;

public class Gaps extends Characterizable {
    boolean axial;
    int a, all, b, big, f, g, little, lotoMinusTwo, n, q;
    String bigger, smaller;

    private int firstNumber(String sequence) {
        int sequenceLength = sequence.length();
        if(sequenceLength == 0) {
            return NOT_FOUND;
        }

        final int ARRAY_SIZE = 10;
        int[] r = new int[ARRAY_SIZE];
        r[0] = sequence.indexOf("0");
        r[1] = sequence.indexOf("1");
        r[2] = sequence.indexOf("2");
        r[3] = sequence.indexOf("3");
        r[4] = sequence.indexOf("4");
        r[5] = sequence.indexOf("5");
        r[6] = sequence.indexOf("6");
        r[7] = sequence.indexOf("7");
        r[8] = sequence.indexOf("8");
        r[9] = sequence.indexOf("9");
        q = sequenceLength;
        for(int i = 0; i < ARRAY_SIZE; ++i) {
            if(r[i] >= 0) {
                if(r[i] < q) {
                    q = r[i];
                }

            }

        }

        if(q == sequenceLength) {
            return NOT_FOUND;
        }

        return q;
    }

    public Gaps(String s, int loto, boolean x) {
        axial = x;
        line = s;
        lotoMinusTwo = loto - 2;

        if(loto == MINILOTO) {
            all = 31;
        } else if(loto == LOTO6) {
            all = 43;
        } else if(loto == LOTO7) {
            all = 37;
        }

    }

    public int getAll() {
        return all;
    }

    public int dateLine() {
        return NON_DATE_LINE;
    }

    public String anchor_res_no() {
        return line;
    }

    public String common() {
        return line;
    }

    public String interposed() {
        return line;
    }

    public String lotoLine() {
        boolean trim = true;

        if(axial) {
            q = line.indexOf(JIKU);
            if(q >= 0) {
                trim = false;
            }
        }

        if(trim) {
            q = firstNumber(line);
            if(q >= 0) {
                line = line.substring(q);
            } else {
                head = line;
                line = EMPTY;
                return head;
            }

        }

        String s = line;
        q = s.indexOf(GAP);
        if(q >= 0) {
            g = q;
            q = g + 1;
            s = line.substring(q);

            for(int i = 0; i < lotoMinusTwo; ++i) {
                q = s.indexOf(GAP);
                if(q >= 0) {
// "03 12 18 24 34 36 37 "
//    g  a                
                    a = g + 1 + q;
                    q = a + 1;
                    s = line.substring(q);
                    g = a;
                    continue;
                } else {
                    break;
                }
            }
        }

        if(q >= 0) {
            ;
        } else { 
// less than six gaps
            head = line;
            line = EMPTY;
            return head;
        }

// six gaps or more
// "03 12 18 24 34 36 37"
//                   g   
        q = g + 1;
        s = line.substring(q);
        q = s.indexOf(GAP);
        if(q >= 0) {
            ;
        } else { // six gaps
            head = line;
            line = EMPTY;
            return head;
        }

// another gap place
// "03 12 18 24 34 36 37 "
//                   g  a 
        a = g + 1 + q;
        q = g + 3;
        s = line.substring(q);
        q = firstNumber(s);
        if(q == NOT_FOUND) {
            q = s.indexOf(QP);
            if(q >= 0) {
                head = line;
                line = EMPTY;
                return head;
            } else { 
// seven numbers
// "03 12 18 24 34 36 37 "
//                   g  a 
                head = line.substring(0, a); // "03 12 18 24 34 36 37"
                line = line.substring(a);
                if( line.equals(GAP) ) {
                    line = EMPTY;
                }

                return head;
            }

        }

// another number place
        n = g + 3 + q;
// "03 12 18 24 34 36 37 0"
//                   g  an 
        q = n + 1;
        s = line.substring(q);
        q = firstNumber(s);
        if(q == NOT_FOUND) {
// one-digit number
// "03 12 18 24 34 36 37 x2"
//                   g  a n 
            head = line.substring(0, n); // "03 12 18 24 34 36 37 x"
            line = line.substring(n);
            return head;
        }

// far number place
// "03 12 18 24 34 36 37 07 10 15 31 32 34 35"
//                   gb anf                   
        f = n + 1 + q;

        b = g + 1;
        q = b + 2;
        bigger = line.substring(b, q);
        try {
            big = Integer.parseInt(bigger);

            q = n + 2;
            smaller = line.substring(n, q);
            little = Integer.parseInt(smaller);

            if(big > little) {
                head = line.substring(0, n); // "03 12 18 24 34 36 37 "
                line = line.substring(n);
            } else { // big <= little
// more than seven numbers
                if(little > all) { /*
    "13 20 25 27 35 36 37 548"    
                      gb anf      */
                    head = line.substring(0, n); // "13 20 25 27 35 36 37 "
                    line = line.substring(n);
                } else {
// "03 12 18 24 33 34 36 37"
//                   gb anf
                    head = line;
                    line = EMPTY;
                }
            }
        } catch(NumberFormatException e10) {
            head = line;
            line = EMPTY;
        }

        return head;
    }

    public String name_id() {
        return line;
    }

    public String rebuild() {
        return line;
    }

}

